<template lang="pug">
  #app.app
    .app__content
      GPMHeader
      GPMTabs(
        :tabs="tabs"
        @change="onTabChangeHandler"
      )
      GPMUserList(:userList="computedUserList")
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'

// Components
import GPMHeader from '@/components/GPM-Header/index.vue'
import GPMTabs from '@/components/UX/GPM-Tabs/index.vue'
import GPMUserList from '@/components/GPM-UserList/index.vue'
import { IUser } from '@/api'
import { getUser } from '@/http/user'

@Component<InstanceType<typeof App>>({
  components: {
    GPMHeader,
    GPMTabs,
    GPMUserList
  }
})
export default class App extends Vue {
  tabs = [
    'All Employees',
    'Architect',
    'Consultant',
    'Producer'
  ]

  activeTab = 0

  userList: IUser[] = []

  get computedUserList (): IUser[] {
    if (this.activeTab === 0) return this.userList
    const designation = this.tabs[this.activeTab]

    return this.userList.filter(user => user.designation === designation)
  }

  onTabChangeHandler (tab: number): void {
    this.activeTab = tab
  }

  async mounted (): Promise<void> {
    this.userList = await getUser()
  }
}

</script>

<style lang="scss">
.app {
  background-color: $main-background-color;
  min-height: 100%;
  padding-top: $padding-top-main-block;
  width: 100%;

  &__content {
    margin: 0 auto;
    max-width: $max-width-main-block;
  }

  .gpm-header,
  .gpm-tabs {
    margin-bottom: 32px;
  }
}
</style>
